<?php
/*
This file is part of Silex - see http://projects.silexlabs.org/?/silex

Silex is  2010-2011 Silex Labs and is released under the GPL License:

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License (GPL) as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
class Date {
	public function __construct($year, $month, $day, $hour, $min, $sec) {
		if( !php_Boot::$skip_constructor ) {
		$this->__t = mktime($hour, $min, $sec, $month + 1, $day, $year);
		;
	}}
	public $__t;
	public function getTime() {
		return $this->__t * 1000;
		;
	}
	public function getPhpTime() {
		return $this->__t;
		;
	}
	public function getFullYear() {
		return intval(date("Y", $this->__t));
		;
	}
	public function getMonth() {
		$m = intval(date("n", $this->__t));
		return -1 + $m;
		unset($m);
	}
	public function getDate() {
		return intval(date("j", $this->__t));
		;
	}
	public function getHours() {
		return intval(date("G", $this->__t));
		;
	}
	public function getMinutes() {
		return intval(date("i", $this->__t));
		;
	}
	public function getSeconds() {
		return intval(date("s", $this->__t));
		;
	}
	public function getDay() {
		return intval(date("w", $this->__t));
		;
	}
	public function toString() {
		return date("Y-m-d H:i:s", $this->__t);
		;
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->dynamics[$m]) && is_callable($this->dynamics[$m]))
			return call_user_func_array($this->dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call '.$m.'');
	}
	static function now() {
		return Date::fromPhpTime(time());
		;
	}
	static function fromPhpTime($t) {
		$d = new Date(2000, 1, 1, 0, 0, 0);
		$d->__t = $t;
		return $d;
		unset($d);
	}
	static function fromTime($t) {
		$d = new Date(2000, 1, 1, 0, 0, 0);
		$d->__t = $t / 1000;
		return $d;
		unset($d);
	}
	static function fromString($s) {
		return Date::fromPhpTime(strtotime($s));
		;
	}
	function __toString() { return $this->toString(); }
}
