<?php
/*
This file is part of Silex - see http://projects.silexlabs.org/?/silex

Silex is © 2010-2011 Silex Labs and is released under the GPL License:

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License (GPL) as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
class Std {
	public function __construct(){}
	static function is($v, $t) {
		return _hx_instanceof($v, $t);
		;
	}
	static function string($s) {
		return _hx_string_rec($s, "");
		;
	}
	static function int($x) {
		return intval($x);
		;
	}
	static function parseInt($x) {
		if(!is_numeric($x)) {
			$matches = null;
			preg_match("/\\d+/", $x, $matches);
			return Std_0($matches, $x);
			unset($matches);
		}
		else {
			return Std_1($x);
			;
		}
		;
	}
	static function parseFloat($x) {
		return is_numeric($x) ? floatval($x) : acos(1.01);
		;
	}
	static function random($x) {
		return rand(0, $x - 1);
		;
	}
	function __toString() { return 'Std'; }
}
;
function Std_0(&$matches, &$x) {
if(count($matches) === 0) {
	return null;
	;
}
else {
	return intval($matches[0]);
	;
}
}
function Std_1(&$x) {
if(strtolower(_hx_substr($x, 0, 2)) === "0x") {
	return intval(substr($x, 2), 16);
	;
}
else {
	return intval($x);
	;
}
}